#include "StatusLabel.h"

#include <QHBoxLayout>

namespace armarx::skills::gui
{

    StatusLabel::StatusLabel()
    {
        this->label = new QLabel("");
        this->resetButton = new QPushButton("");
        this->setupUi();
    }

    void
    StatusLabel::handleMessage(const std::string& message, std::string const& error)
    {
        this->label->setText(QString::fromStdString(message));
        this->resetButton->setHidden(false);
        label->setToolTip(QString::fromStdString(error));
    }

    void
    StatusLabel::resetLabel()
    {
        this->label->setText(QString::fromStdString(""));
        this->resetButton->setHidden(true);
    }

    void
    StatusLabel::setupUi()
    {
        QHBoxLayout* layout = new QHBoxLayout();
        layout->addWidget(resetButton);
        layout->addWidget(label);
        this->setLayout(layout);
        layout->setStretch(1, 2);
        label->setStyleSheet("QLabel { color : red; }");
        this->resetButton->setHidden(true);

        label->setMinimumHeight(35);
        label->setMaximumHeight(35);

        QPixmap pixmap(":/icons/delete.ico");
        QIcon ButtonIcon(pixmap);
        resetButton->setIcon(ButtonIcon);
        resetButton->setIconSize(pixmap.rect().size() / 2);

        connect(this->resetButton, &QPushButton::clicked, this, &StatusLabel::resetLabel);
    }

} // namespace armarx::skills::gui
