#pragma once

#include <QLabel>
#include <QPushButton>

namespace armarx::skills::gui
{
    class StatusLabel : public QWidget
    {
    public:
        /**
         * @brief Constructor for StatusLabel
         */
        StatusLabel();

    public slots:
        /**
         * @brief Display a message to indicate an update.
         */
        void handleMessage(std::string const& message, std::string const& error);

    private slots:
        /**
         * @brief Reset the label to default state.
         */
        void resetLabel();

    private:
        void setupUi();

        // contents
        QLabel* label = nullptr;
        QPushButton* resetButton = nullptr;
    };
} // namespace armarx::skills::gui
